/* File client.c */
#include "inclusioni.h"

#define ALLOCA
#include "globali.h"


char *modo[]={"netascii","octet"};	

void CTRL_C_handler();				/*  gestice il  CRTL+C per interrompere un'operazione	*/       	
void ready();					/*  stampa il prompt					*/
void status();					/*  stampa il contenuto delle variabili utente  	*/
void help();					/*  fornisce l'elenco dei comandi e la loro sintassi 	*/
void quit();					/*  eventuale cleanup ed esce 				*/
void get(char *remoto,char *locale,struct sockaddr_in *server_addr);/*  effettua il download di un file */
void put(char *locale,char *remoto,struct sockaddr_in *server_addr);/*  effettua l' upload di un file 	*/
char 	server_name[MAX_BUF]={"localhost"};;
struct 	sockaddr_in	server_addr;
char *srtt[]={"Exponential backoff=OFF and no RTT prediction","RTT_smoothed","RTT_standard"};

main(int argc, char **argv)
{
int c;
server_addr.sin_family      = AF_INET;
server_addr.sin_addr.s_addr = htonl(INADDR_NONE);
server_addr.sin_port        = htons(DEFAULT_PORT);

while((c=getopt(argc,argv,"r:p:hHv"))!=-1)  	/*  Parsing della linea di comando 			*/
{
switch(c)
{	
case 	'p':		printf("Il server verra' contattato sulla porta %d\n",server_addr.sin_port = htons(atoi(optarg)) );
			break;
case 	'v':		verbose_flag = 1;printf("Verbose\n");
			break;
case	'h':case 'H':	
			printf("\n%s versione del %s\n",argv[0],__DATE__);

case 	'r':		predictor_type=atoi(optarg);            	
			if((predictor_type<NO_PREDICTOR)||(predictor_type>RTT_UPDATE))
			 predictor_type=APPROX_RTT_UPDATE;
			printf("Predizione del ritardo %s\n",srtt[predictor_type]) ;
                        break;
			
default:		
			printf("\nClient TFTP \n");
			printf("\nUSO: %s \t[host] -opzioni \n\n",argv[0]);
			printf("\t\t-h Help\n");
			printf("\t\t-r[0..2]seleziona il predictor type [default %d = %s]\n",predictor_type,srtt[predictor_type]);
			printf("\t\t-p numero_porta [default:  %d]\n",DEFAULT_PORT);
			printf("\n");
			exit(0);
	 	   }
} 
if (optind < argc)		/* ci sono  altri argomenti nella linea di comando probabine HostName	*/
{
 if((server_addr.sin_addr.s_addr = inet_addr(argv[optind]))!=INADDR_NONE)/* se e' un indirizzo dotted decimal valido 	*/
   {
          /* server_name <= gethostbyaddr () */
   }
   else{
   	struct hostent *h;	
	h=gethostbyname(argv[optind]);   				/* sara' un indirizzo a dominio */
	if(h!=NULL)
		{
		server_addr.sin_addr.s_addr =*((u_long*)h->h_addr);
		strncpy(server_name,argv[optind],MAX_BUF);
		printf("Le richieste saranno inoltrate a %s, porta %hd\n",server_name,ntohs(server_addr.sin_port));	
		}
		else
		perror("gethostbyname");
	}
	

}


Signal(SIGINT,CTRL_C_handler);
ready();
yylex();

}
/***************************************************************************/
void CTRL_C_handler()
{
CTRL_C=ON;
return;
}

/***************************************************************************/
void get(char *remoto,char *locale,struct sockaddr_in *server_addr)		/* effettua il download di un file */
{
int 	file,i,n,dgram_len,ack_ok,block,rexmit=0,sd;
char 	buffer[MAX_BUF+1];
tftp 	*tftp=(void*)buffer;

CTRL_C=OFF;
if (locale ==NULL) locale = remoto;
printf("get %s %s\n",remoto,locale);

file=open(locale,O_WRONLY | O_CREAT |O_TRUNC, S_IWUSR  );
if(file <0)
 {
 perror("get ");
 return;
 }

/* Componi RRQ  */
tftp->opcode = htons(RRQ);             	/* imposta opcode */	
strncpy(buffer+TFTP_OPCODE_LEN,remoto,MAX_BUF-9);/* occore lasciar spazio al transmission mode , nel caso di nomi lunghissimi */
strcpy(buffer+TFTP_OPCODE_LEN+strlen(remoto)+1,(t_mode==octet)?"octet":"netascii");
dgram_len=strlen(remoto)+((t_mode==octet)?5:8)+TFTP_HEADER;/* 5 e 8 byte sono la lunghezza delle stringhe octet e netascii + opcode + 2 \0 */


sd = Socket_udp(0);		

init_RTT_predictor();

block=1;
do
{

 ack_ok = send_reliable(sd,server_addr,buffer,&dgram_len);	
 n=dgram_len-TFTP_HEADER;
 if(ack_ok == OK)
  write(file,buffer+TFTP_HEADER,n);

  tftp->opcode=htons(ACK);     		
  tftp->n_block=htons(block++);                   			/* ACK block#= 1...n*/
  dgram_len=TFTP_HEADER;

} while ((n == TFTP_DATA_LEN)&& (ack_ok == OK)&& (CTRL_C==OFF) ); /* finche' arrivano DATA di 512b ytes*/

Close(file);

if(CTRL_C==ON)
  printf("trasferimento interroto\n");
else		
if( ack_ok == ERRORE)
  { printf("tempo scaduto riprovare piu tardi\n");unlink(locale);}
else
if( ack_ok == OK)
 {
 write(sd,buffer,dgram_len);         /*	invio l'ultimo ack*/	       	
 printf("%s scritto con successo\n",locale);
 }

Close(sd);
}

/*******************************************************************/
void put(char *locale,char *remoto,struct sockaddr_in *server_addr)    /* effettua il upload di un file */
{
int 	file,sd,i,n,ack_ok,block,rexmit=0;
char 	ack[4];	 	
char 	buffer[MAX_BUF+1];
tftp 	*tftp=(void*)buffer; 	

fd_set 	fd;

int 	dgram_len,len;


if (remoto == NULL) remoto = locale;	
 printf("put %s %s\n",locale,remoto);

file=open(locale,O_RDONLY);
if(file <0)
 {
 perror("put ");
 return ;
 }


tftp->opcode = htons(WRQ);             	/* imposta opcode */	
strncpy(buffer+TFTP_OPCODE_LEN,remoto,MAX_BUF-9);/* occore lasciar spazio al transmission mode , nel caso di nomi lunghissimi */
strcpy(buffer+TFTP_OPCODE_LEN+strlen(remoto)+1,(t_mode==octet)?"octet":"netascii");
dgram_len=strlen(remoto)+((t_mode==octet)?5:8)+TFTP_HEADER;/* 5 e 8 byte sono la lunghezza delle stringhe octet e netascii + opcode + 2 \0 */

if((sd=Socket_udp(0)) == ERRORE)
	{
	perror("Socket()");
	exit(0);
	}

CTRL_C=OFF;
init_RTT_predictor();
block=0;
ack_ok = send_reliable(sd,server_addr,buffer,&dgram_len);	
if(( ack_ok == ERRORE) || ( ack_ok == ERROR))
   printf("Impossibile iniziare WRQ riprovare piu' tardi\n");
else
{
 do
 {
  len=read(file,buffer+TFTP_HEADER,TFTP_DATA_LEN);
  tftp->opcode=htons(DATA);     		
  tftp->n_block=htons(++block);                 			/* data block#= 1...n*/
  dgram_len=TFTP_HEADER+len;
  ack_ok = send_reliable(sd,server_addr,buffer,&dgram_len);

 } while ((len == TFTP_DATA_LEN)&& (ack_ok == OK) &&(CTRL_C==OFF) ); /* finche' c'e' file e niente errori*/

 if(CTRL_C==ON)
  printf("trasferimento interroto\n");
 else		
 if( ack_ok == ERRORE)
   printf("tempo scaduto riprovare piu tardi\n");
 else
 if ( ack_ok == OK)
   printf("File %s trasferito.\n",locale);
 }
Close(file);
Close(sd);
}

/********************************************************/                                                                         	
void ready()			/* Stampa il prompt	*/
{
printf("tftp>");
}

/*******************************************************************************/                                                                         	
void status()			/* Stampa il contenuto delle variabili utente  */
{
printf("Status:\n");

if(server_addr.sin_addr.s_addr != INADDR_NONE)
 {
printf("Default host   :  %s,%d\n",server_name,ntohs(server_addr.sin_port));
  }
else printf("Nessun server di default\n");
printf("Mode           :  %s\n",(t_mode==netascii)?"Netascii":"Octet");
printf("Verbose        :  %s\n",(verbose_flag==ON)?"ON":"OFF");
printf("Trace          :  %s\n",(trace_flag==ON)?"ON":"OFF");
printf("Max Timeout             =  %d\n",packet_timeout);
printf("Total Timeout  (rexmt)  =  %ds\n",total_timeout);
printf("Prediction type:  %s\n",srtt[predictor_type]);
}

/************************************************************************************/
void help()			/* Fornisce l'elenco dei comandi e la loro sintassi */
{
printf("Tftp client: \nComandi:\n\n");
printf("\tconnect host        connect to remote tftp\n");
printf("\tmode mode           set file transfer mode == netascii/octet\n");
printf("\tput file1 [file2]   send [locale_filename] [as remote_filename]\n");
printf("\tget file1 [file2]   receive [remote_filename] [as local_filename]\n\n");

printf("\tCTRL+C              abort put/get\n");
printf("\tquit or q           exit tftp\n");
printf("\tbinary              \"mode octet\"\n");
printf("\tascii               \"mode ascii\"\n\n");

printf("\tverbose             toggle verbose mode\n");
printf("\ttrace               toggle packet tracing\n");
printf("\tstatus              show current status\n");
printf("\trexmt               set per-packet retransmission timeout\n");
printf("\ttimeout             set total retransmission timeout\n\n");
printf("\tpredictor           change predictor type\n\n");

printf("\tcd                  change local dir\n");
printf("\trm                  remove local file\n");
printf("\ttls                 list local dir\n");
printf("\tsh xxx              shell xxx command\n");
printf("\t? or help           print help information\n\n");
}

/*************************************************************/
void quit()			/* Eventuale cleanup ed esce */
{
printf("goodbye !\n\n");
}

