/* File comandi.c */
#include "globali.h"

void double_timer();          	/*			*/
void no_predictor(long misura);	        /* non aggiorna RTT */
void rtt_update(long misura);		/* aggiorna RTT con approssimazione della deviazioane standard */
void approx_rtt_update(long misura);	/* aggiorna RTT con approssimazione della deviazioane media*/

void (*RTT_vect[3])(long )={no_predictor,approx_rtt_update,rtt_update};



char *error_codes[]	={ "Not defined, see error message",\
			   "File not found",\
			   "Access violation",\
			   "Disk full or allocation exceeded",\
			   "Illegal TFTP operation",\
			   "Unknown tranfer ID",\
			   "File already exists",\
			   "No such user"} ;
						   			
void print_tftp_dgram(char *dgram,int dgram_len,int dir)
{
tftp	*tftp;
tftp=(void *)dgram;

if(trace_flag==ON)
  {
   struct timeval timestamp;
   gettimeofday(&timestamp,NULL);
   printf("[%2d:%06d]",timestamp.tv_sec%60,timestamp.tv_usec);
   printf("[%d] %s",getpid(),(dir==OUT)?"Invia :":"Riceve:");	/* direzione del pacchetto */

  }

switch( ntohs(tftp->opcode))
 {
 case RRQ:	printf("RRQ    %s  [%3d bytes],",(char*)&(tftp->n_block),dgram_len);	
		printf("[%s] ",( *(dgram+dgram_len-2)=='t')?"octet":"netascii");   /*distinguo i modi dall'ultimo caratere */
		break;
 case WRQ:	printf("WRQ    %s  [%3d bytes],",(char*)&(tftp->n_block),dgram_len);	
		printf("[%s] ",( *(dgram+dgram_len-2)=='t')?"octet":"netascii"); 		
 		break;
 case DATA:	printf("DATA  #%u [%3d bytes] ",ntohs(tftp->n_block),dgram_len); 	break;
 case ACK: 	printf("ACK   #%u [%3d bytes] ",ntohs(tftp->n_block),dgram_len);	break;
 case ERROR:	printf("ERROR #%u %s  [%3d bytes] ",ntohs(tftp->n_block),error_codes[ntohs(tftp->n_block)],dgram_len);
		if(ntohs(tftp->n_block)==0)
		    printf("%s ",(char *) tftp+1);/* incremento puntatore alla struttura per accedere al primo carattere dell'ErrMsg */
                break;
 default: printf("Pacchetto sconociuto");
  }

  putchar('\n');
//  printf("INVIATI %d\nRICEVUTI %d\nDUPLICATI %d -s = %f\n",inviati,ricevuti,duplicati,(float)(inviati-ricevuti)/(float)inviati);

}

void init_RTT_predictor()
{
timer 	= START_TIMER;
RTT     = 0;
StanDev = 750000;
inviati = 0;
ricevuti= 0;
X=0;
N=0;
ACC=0;
N_sigma=0;
sigma=0;
}

/*********************************************************/
void timeout()          	/*			*/
{
if(verbose_flag==ON)
printf("Timer %f scaduto %s\n",(double)timer / M,(predictor_type==NO_PREDICTOR)?"":"raddoppio il timer");

if(predictor_type == NO_PREDICTOR)
	timer=1*M;	
else timer  = exponential_bakoff*timer;

}


/*********************************************************/
void rtt_update(long misura)	/*			*/
{
long delta;
delta   = misura - RTT;
RTT     = RTT + ALPHA * delta;

if(verbose_flag==ON) printf("EX : TO= %fs, Sam= %fs, RTT= %fs, sDev= %fs\n",(double)timer / M,(double)ritardo / M,(double)RTT / M,(double)sigma / M);	

N++;
ACC += misura;
X    = ACC/N;
N_sigma = N_sigma+pow((misura - X),2);
sigma=sqrt(N_sigma/(double)N);
timer   = RTT+2*(long)sigma;

if(verbose_flag==ON) printf("NEW: TO= %fs, Sam= %fs, RTT= %fs, sDev= %fs\n",(double)timer / M,(double)ritardo / M,(double)RTT / M,(double)sigma / M);	
}

void no_predictor(long misura)
{
timer   = 1*M;
}


void approx_rtt_update(long misura)	/*			*/
{
long delta;
if(verbose_flag==ON) printf("EX : TO= %fs, Sam= %fs, RTT= %fs, mDev= %fs\n",(double)timer / M,(double)ritardo / M,(double)RTT / M,(double)StanDev / M);	

delta   = misura - RTT;
RTT     = RTT + ALPHA * delta;
StanDev = StanDev + BETA *(labs(delta)-StanDev);
timer   = RTT+4*StanDev;   /* sui testi suggeriscono 4*STDEV*/

if(verbose_flag==ON) printf("NEW: TO= %fs, Sam= %fs, RTT= %fs, mDev= %fs\n",(double)timer / M,(double)ritardo / M,(double)RTT / M,(double)StanDev / M);	

}

/************************************************************************/
struct 	timeval set_timer(long timer)	/*  Restituisce il timer per la select	*/		
{
 struct timeval sel_timer;
 ldiv_t temp;

if(timer<MIN_TIMER)
  { timer=MIN_TIMER;if(verbose_flag==ON)  printf("RIALZATO TIMER  %f\n",(double)timer/M);}
else
  if(timer>MAX_TIMER)
//if ( (float)(inviati-ricevuti)/(float)inviati <0.25)   /* percentuale non troppo alta di pacchetti persi   */
   { timer=MAX_TIMER;if(verbose_flag==ON)  printf("ABBASSATO TIMER %f\n",(double)timer/M);}
//else							  /* percentuale non troppo alta di pacchetti persi,    */
//    { timer=MIN_TIMER;if(verbose_flag==ON)  printf("AZZERATO %f\n",(double)timer/M);}


 temp = ldiv((long)timer,M);      /* funziona anche   *(ldiv_t*)&sel_timer=ldiv((long)timer,M)    */
 sel_timer.tv_sec  = temp.quot;		
 sel_timer.tv_usec = temp.rem;
return sel_timer;	
}

/************************************************************/
void Close(int fd)
{
if(close(fd)==ERRORE)
  {
  perror("close");
  exit(ERRORE);
  }
}


/************************************************************/
int Socket_udp(u_short port)
{
int sd;
struct	sockaddr_in local_addr;

if((sd=socket(AF_INET,SOCK_DGRAM,IPPROTO_UDP)) == ERRORE)
	{
	perror("Socket()");
	exit(ERRORE);
	}

bzero((char *) &local_addr, sizeof(local_addr));
local_addr.sin_family      = AF_INET;
local_addr.sin_addr.s_addr = htonl(INADDR_ANY);
local_addr.sin_port        = htons(port);

if(bind(sd,(void *)&local_addr,sizeof(local_addr))== ERRORE)
	{
	perror("Bind()");
	exit(ERRORE);
	}
return sd;
}



/********************************************************************************************************/
int send_reliable(int sd,struct sockaddr_in *dest,char *buffer,int *dgram_len)    /*  In via in modo affidabile un pacchetto   */
{
int i = 0,n,block;
int ack_ok = OK;
int rexmit = 0;
char 	ack[MAX_BUF+1];
fd_set	fd;
u_short curr_port=0;
ldiv_t temp;
tftp	*request=(void*)buffer,*reply=(void*)ack;
struct 	timeval start_time,stop_time,sel_timer;
struct  sockaddr_in peer;

switch( ntohs(request->opcode))		/* numero seriale del pacchetto atteso come risposta*/
{
case WRQ: block = 0;break;
case RRQ: block = 1;break;	
case DATA:block = ntohs(request->n_block);break;
case ACK: block = ntohs(request->n_block)+1;break;
}


while((!ack_ok)&& (rexmit < MAX_RETRY))
{
 if( ( ntohs(request->opcode)==RRQ) || (ntohs(request->opcode)==WRQ) )	/* se si tratta di RRQ o WRQ */
   n=sendto(sd,buffer,*dgram_len,0,(void*)dest,sizeof(struct sockaddr_in));
  else
  n=write(sd,buffer,*dgram_len);
  if(n<1)
   {
   perror("WRITE/SENDTO");
   print_tftp_dgram(buffer,n,OUT);
   return ERRORE;
   }
inviati++;
if(trace_flag==ON)  print_tftp_dgram(buffer,n,OUT);

  gettimeofday(&start_time,NULL);				/* Segno il tempo di invio */

 FD_ZERO(&fd);
 FD_SET(sd,&fd);
 sel_timer = set_timer(timer);

// printf("TO_PESATO = %f\n",   ((double)timer*(inviati - ricevuti)/(double)inviati)/M);
qui:

switch(select(sd+1, &fd, (fd_set *) 0, (fd_set *) 0, &sel_timer))
 {
 case -1:	perror("select error");return ERRORE;
 case  0:	timeout();
 		rexmit++;
 		break;
 case  1:	gettimeofday(&stop_time,NULL);
 	 if( ( ntohs(request->opcode)==RRQ) || (ntohs(request->opcode)==WRQ) )	/* se si tratta di RRQ o WRQ */	
 	  	{
 	  	i=sizeof(struct sockaddr_in);
		n=recvfrom(sd,ack,MAX_BUF,0,(void*)&peer,&i);
  		}
          else
 	   	n=read(sd,ack,MAX_BUF); 	
  	if(n==-1)
  	{
  	 perror("Recvfrom/Read");
  	 return ERRORE;		
  	 }
  	ricevuti++;
	if(trace_flag==ON)
		print_tftp_dgram(ack,n,IN);	
	if( ((ntohs(reply->opcode)==ACK) || (ntohs(reply->opcode)==DATA) )&&(ntohs(reply->n_block)!=block) ) /* si tratta di un ACK duplicato*/
		{
		duplicati ++;
                ritardo =   (stop_time.tv_sec - start_time.tv_sec)*M+(stop_time.tv_usec- start_time.tv_usec);		
 		sel_timer = set_timer(timer-ritardo);
                if(verbose_flag==ON)
                  printf("\nACK/DATA Duplicato %d  TO= %f  argselect= %lu,%06lu,\n\n",ntohs(reply->n_block),(double)timer / M,sel_timer.tv_sec, sel_timer.tv_usec);
		goto qui;
		
		}
	if( ((ntohs(reply->opcode)==ACK)|| (ntohs(reply->opcode)==DATA)&&(ntohs(reply->n_block)==block) ) ) /* e' l'ACK/DATA che aspettavo*/	
 		{		
		      	ack_ok=1;
	      	 if( ( ntohs(request->opcode)==RRQ) || (ntohs(request->opcode)==WRQ) )	/* se la req era una RRQ o WRQ  */	
		      if(connect(sd,(void*)&peer,sizeof(struct sockaddr_in))== ERRORE)
        			{
				perror("Socket()");
				return ERRORE;
				}
		 if (rexmit == 0)    /* e' un sample valido per calcolo di rtt secondo Karn */
                            {
                            ritardo =   (stop_time.tv_sec - start_time.tv_sec)*M+(stop_time.tv_usec- start_time.tv_usec);
                            RTT_vect[predictor_type]( ritardo );
                            }
		       	
		       	}
		    else
	if( ntohs(reply->opcode)==ERROR ) 		
		    {
		    printf("Ricevuto errore : ");
    		    print_tftp_dgram(ack,n,IN);	
		    return ERROR;
		    }
		   else rexmit++;
		      	
			break;		
    }            // end switch

 } 	        // end while

if (rexmit>=MAX_RETRY)
  {
  printf("Tempo finito riprovare piu' tardi\n");
  return ERRORE;
  }
 *dgram_len=n;
  memcpy((void*)buffer,(void*)ack,MAX_BUF); 	
  return OK;

}



/*******************************************************************************************************************/
void send_error(int sd,struct sockaddr_in *dest,int ErrorCode,char *ErrMsg)	/* invia un messaggio d'errore TFTP*/
{
char buffer[MAX_BUF];

print_tftp_dgram(buffer,TFTP_HEADER+strlen(ErrMsg)+1,OUT);

((tftp*)buffer)->opcode = htons(ERROR);
((tftp*)buffer)->n_block= htons(ErrorCode);

strncpy(buffer+TFTP_HEADER,ErrMsg,TFTP_DATA_LEN-(TFTP_HEADER+1));
buffer[TFTP_HEADER+strlen(ErrMsg)]='\0';

if(sendto(sd,buffer,TFTP_HEADER+strlen(ErrMsg)+1,0,(void*)dest,sizeof(struct sockaddr_in))==ERRORE)
	perror("Sendto");

}

void Signal(int signo,void (*func)(int) )	/* wrapper function per ansi sinal() */
{                                               /* questa rialza SA_RESTART per riavviare syscalls interrotte */
struct sigaction t,t1;

t.sa_handler = func;
sigemptyset(&t.sa_mask);
t.sa_flags=0;
t.sa_flags |= SA_RESTART;
if(sigaction(signo,&t,&t1)<0)
 perror("Non posso installare l'handler");

}



