/* File inclusioni.h */

#ifndef INCLUSIONI_H
#define INCLUSIONI_H
	
#include <stdio.h>

#include <stdlib.h>
#include <math.h>
#include <unistd.h>
#include <string.h>
#include <signal.h>
#include <fcntl.h>
#include <errno.h>

#include <sys/time.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>

#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>

#define	TFTP_DATA_LEN	512
#define	TFTP_OPCODE_LEN	2
#define	TFTP_HEADER	4
#define	TFTP_PAKET_LEN	TFTP_HEADER + TFTP_DATA_LEN


#define	RRQ  		1       /* opcodes TFTP */
#define	WRQ		2
#define	DATA		3
#define	ACK		4
#define	ERROR		5

#define	MAX_BUF		TFTP_PAKET_LEN+1
#define	OFF 		0
#define	ON		1
#define	DEFAULT_PORT 	1500

#define	ERRORE		-1	/* errori di trsmissione*/
#define	OK		0

#define	ALPHA		0.125	    /* 1/8 guadagno del RTT */
#define	BETA		0.25	    /* 1/4 guadagno della dev med*/			
#define	START_RTT 	500000      /* RTT in microsecondi*/
#define	START_TIMER 	3*M         /* RTT in microsecondi*/
#define	M		1000000L    /* un long  milione ..*/

#define	MAX_RETRY	10
#define MIN_TIMER       0.005*M
#define MAX_TIMER	8*M
#define	IN		0
#define	OUT		1

#define NO_PREDICTOR		0
#define APPROX_RTT_UPDATE	1
#define RTT_UPDATE		2

typedef	struct tftp_mask {
			u_short opcode;
			u_short	n_block;
			} tftp;

void print_tftp_dgram(char *dgram,int dgram_len,int dir);
int  Socket_udp(u_short port);
int  send_reliable(int sd,struct sockaddr_in *dest,char *buffer,int *dgram_len);    /*  In via in modo affidabile un pacchetto   */
void send_error(int sd,struct sockaddr_in *dest,int ErrorCode,char *ErrMsg);	/* invia un messaggio d'errore TFTP*/
void Close(int fd);

void init_RTT_predictor();     	/*			*/

struct 	timeval set_timer(long timer);	/*  Restituisce il timer per la select	*/		

#endif

#ifndef INADDR_NONE
#define INADDR_NONE	0	/*deprecate usare inetaton() */
#endif


