/* File server.c*/

#define ALLOCA
#include "globali.h"

typedef struct p {
	int 			file;
	struct sockaddr_in 	client;
		  	}
		  	*param;

struct timeval a,b;

extern int errno;
 	
char *modo[]={"netascii","octet"};	

void WRQ_dispatch(void *);
void RRQ_dispatch(void *);		  	
int  parse_args(int sd,struct sockaddr_in *client_addr,char *buffer,int dgram_len,char *filename);	/* preleva argomendi dal WRQ/RRQ	*/

main(int argc, char **argv)
{
param parametri;		  				
char buffer[MAX_BUF];				/*	*/	
char ack[MAX_BUF];	
char filename[MAX_BUF];					
u_short	port=DEFAULT_PORT;				/* Porta server  Posix.1g uint16_t */
struct 	sockaddr_in server_addr,client_addr;
struct  timeval	timer;

int 	i,c,file,sd,addr_len,dgram_len;				
tftp 	*tftp=(void *)buffer;
char *srtt[]={"Exponential backoff=OFF and no RTT prediction","RTT_smoothed","RTT_standard"};


gettimeofday(&timer,0);			
srand(timer.tv_usec);                   /* inizializzo il generatore di numeri casuale col tempo */


while((c=getopt(argc,argv,"r:p:hHvt"))!=-1)  	/*  Parsing della linea di comando */
{
switch(c)
{	
case 'p':	printf("Server in ascolto sulla porta %d\n",port=atoi(optarg));
		break;
		
case 't':	trace_flag=ON;
		printf("Trace dei pacchetti attivo\n");
		break;

case 	'r':		predictor_type=atoi(optarg);            	
			if( (predictor_type<NO_PREDICTOR)||(predictor_type>RTT_UPDATE) )
			 predictor_type=APPROX_RTT_UPDATE;
			printf("Predizione del ritardo %s\n",srtt[predictor_type]) ;
                        break;
		

case 'v':	verbose_flag = ON;printf("Verbose\n");break;
case 'h':case 'H':	
			printf("\n%s versione del %s\n",argv[0],__DATE__);
default:		printf("\nServer TFTP \n");
			printf("\nUSO: %s \t-opzioni [parametro_opz] \n\n",argv[0]);
			printf("\t\t-h Questo Help\n");
			printf("\t\t-p numero_porta [default:  %d]\n",DEFAULT_PORT);
			printf("\t\t-r[0..2]seleziona il predictor type [default %d = %s]\n",predictor_type,srtt[predictor_type]);
			printf("\t\t-t Attiva il trace dei pacchetti\n");
			printf("\t\t-v Attiva la modalita' verbose\n");
			
			printf("\n");
			exit(0);
	 	   }  
} 						/* end while */

if (optind < argc)	/* ci sono  altri argomenti nella linea di comando probabile HostName */
{
printf("Opzione ignorata: %s\n",argv[optind]);

}	

if((sd=Socket_udp(port)) == ERRORE)           /*chiamare socket_udp(....)*/
	{
	perror("Socket()");
	exit(0);
	}


while(1)
{
addr_len=sizeof(struct sockaddr_in);
dgram_len = recvfrom(sd,buffer,MAX_BUF, 0,(void*)&client_addr,&addr_len);

if(dgram_len == ERRORE)
 {
 perror("recvfrom()");		
 continue;
 }

if(trace_flag==ON) print_tftp_dgram(buffer,dgram_len,IN);

switch( parse_args(sd,&client_addr,buffer,dgram_len,filename) )
	{
	case	RRQ:		
		if((file = open(filename,O_RDONLY))==ERRORE)
		  {		
                   perror("open");
		   switch (errno)
		    {
		    case ENOENT: 	send_error(sd,&client_addr,1,"File not found");	break;
		    case EACCES:	send_error(sd,&client_addr,2,"Access violation");break;		
		    default:		/*send_error(sd,&client_addr,sys_errlist[errno]); solo linux*/		    			
		    			send_error(sd,&client_addr,0,"Not defined error");break;		
		    			break;
		    }
		  }
		
		else {
		parametri=malloc(sizeof(struct p));
		parametri->file=file;
		parametri->client=client_addr;
		
		  if (pthread_create(&i,NULL,&RRQ_dispatch,(void *)parametri)  != 0)
 			 printf("Error in thread creation\n");

                  }
		
		break;
	case    WRQ:	
		if((file = open(filename,O_WRONLY | O_CREAT |O_TRUNC, 0600))==ERRORE)
		  {	
                    perror("open");
  		   switch (errno)
		    {
		    case ENOSPC: 	send_error(sd,&client_addr,3,"Disk full");break;
		    case EACCES:	send_error(sd,&client_addr,2,"Access violation");break;		
		    default:		/*send_error(sd,&client_addr,sys_errlist[errno]);*/
		    			send_error(sd,&client_addr,0,"Not defined error");break;		
		    			break;
		    	}

		    }
		
		  else
		  {	  		
		  parametri=malloc(sizeof(struct p));
		  parametri->file=file;
		  parametri->client=client_addr;
		
		  if (pthread_create(&i,NULL,&WRQ_dispatch,(void *)parametri)  != 0)
 			 printf("Error in thread creation\n");

                   }
		   break;
	case 	 ERROR:printf("Ricevuto ERROR\n");break;/* Nessun ACK ne ERRORE su ERRORE */	
	default: send_error(sd,&client_addr,4,"Illegal TFTP operation");		    	  		
		 perror("Illegal TFTP operation");	

	}
  
 } 
	
	

}  /* end main() */

/*****************************************************************************************************************/
int parse_args(int sd,struct sockaddr_in *client_addr,char *buffer,int dgram_len,char *filename)	/* preleva argomendi dal WRQ/RRQ	*/
{
int i;
tftp *tftp=(void *)buffer;

if (buffer[dgram_len-1]!=0)	/* l'ultimo carattere di un una richiesta TFTP deve essere = 0*/
 {
 send_error(sd,client_addr,0,"Bad datagram ");
 printf("Bad datagram \n");
 return ERROR;
 }

for (i=2;(i<dgram_len) && buffer[i];i++)
	filename[i-2]=buffer[i];
filename[i-2]='\0';

if (++i >= dgram_len) 			 		/* bad RRQ */
 {
 send_error(sd,client_addr,0,"Bad RRQ/WRQ too long filename");
  printf("Bad too long filename\n");
 return ERROR;
 }

if(strncmp(buffer+i,modo[octet],strlen(modo[netascii]))==0 )		/* imposta il modo di trasferimento occorre un controllo case insensitive */
 t_mode=octet;
else if (strncmp(buffer+i,modo[netascii],strlen(modo[netascii]))==0 )
 t_mode=netascii;
else
{
 send_error(sd,client_addr,0,"Unknown tranfer mode");
  printf("Unknown tranfer mode\n");
 return ERROR;
}

return ntohs(tftp->opcode);

}


/*******************************************************************************************/
void rand_delay()		/* Genera un ritardo casuale compreso tra 0 e 3 secondi	*/
{
/*  ERRORI VARI
int 	caos,second,usecond;
double  dd;

caos = rand();	

second  = ((int) (3E6*caos/(RAND_MAX+1.0))% M;						
usecond = ((int) (3E6*caos/(RAND_MAX+1.0))/ M;						

printf("Delay   %lu,%06lu s \n",timer.tv_sec,timer.tv_usec);
sleep(second);
usleep(usecond);
*/

}


/***************************************************************/

void RRQ_dispatch(void *p)
{
param parametri=p;
char buffer[MAX_BUF];				/*	*/	
char ack[MAX_BUF];	

u_short block;
u_short *op;
int len,i,ack_ok,sd,dgram_len;
tftp *tftp=(void*)buffer;
struct sockaddr_in *client_addr=&parametri->client;
int file=parametri->file;

pthread_detach(pthread_self());

sd=Socket_udp(0);

if(connect(sd,(void*)client_addr,sizeof(*client_addr))== ERRORE)
        {
	perror("Connect()");
	exit(0);
	}

init_RTT_predictor();
block =0;

do
{
 len=read(file,buffer+TFTP_HEADER,TFTP_DATA_LEN);
 tftp->opcode=htons(DATA);     		
 tftp->n_block=htons(++block);                 			/* data block#= 1...n*/
  dgram_len=TFTP_HEADER+len;

  ack_ok = send_reliable(sd,client_addr,buffer,&dgram_len);

} while ((len == TFTP_DATA_LEN)&& (ack_ok == OK) ); /* finche' c'e' file e niente errori*/
	
if( ack_ok == ERROR)
  if(verbose_flag==ON)printf(" tempo scaduto riprovare piu tardi");

Close(file);
Close(sd);
free(p);
pthread_exit(NULL);

}

/***************************************************************/
void WRQ_dispatch(void *p)
{

param parametri=p;
int 	i,ack_ok,n,sd,dgram_len;				
u_short block;
char buffer[MAX_BUF];				/*	*/	
tftp *tftp=(void*)buffer;
struct sockaddr_in *client_addr=&parametri->client;
int file=parametri->file;


pthread_detach(pthread_self());

sd=Socket_udp(0);

if(connect(sd,(void*)client_addr,sizeof(*client_addr))< 0)  	/* Imposta solo l'endpoint di default permettendo di usare write()  */
        {						/* anziche' sendto. NON Instaura Alcuna Connessione del livello trasporto */
	perror("connect()");				
	exit(0);
	}
	


tftp->opcode 	= htons(ACK);
tftp->n_block	= htons(block=0);
dgram_len 	= TFTP_HEADER;

init_RTT_predictor();
do
{

 ack_ok = send_reliable(sd,client_addr,buffer,&dgram_len);	
 n=dgram_len-TFTP_HEADER;
 if(ack_ok == OK)
  write(file,buffer+TFTP_HEADER,n);

  tftp->opcode=htons(ACK);     		
  tftp->n_block=htons(++block);			/* ACK block#= 1...n*/
  dgram_len=TFTP_HEADER;

} while ((n == TFTP_DATA_LEN)&& (ack_ok == OK) ); /* finche' arrivano DATA di 512b ytes*/

if( ack_ok == ERROR )	
  {
  if(verbose_flag==ON)
  printf("Trasferimento fallito\n");     	
  }
else    {	
        if(trace_flag==ON) print_tftp_dgram(buffer,dgram_len,OUT);
	if(write(sd,buffer,dgram_len)==ERRORE)         /*	invio l'ultimo ack*/	       	
	  perror("Last Write\n");
	else
	   if(verbose_flag==ON)printf("File trasferito\n");
	
	}

Close(sd);
Close(file);
free(p);
pthread_exit(NULL);
}

